; ##############################################################################
; ##############################################################################
; ##############################################################################
STARTWERTE:
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
	ldi TEMP,(1<<WDCE)|(1<<WDE) ; Watchdog aktivieren (max. Zeit)				
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (SRAM_START)
	ldi ZH, HIGH(SRAM_START)
	ldi temp,0
;-------------------------------------------------------------------------------
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PORT_INITIALISIERUNG:
	clr temp
	out DDRB, temp
	out DDRC, temp
	out DDRD, temp
	out PORTB,temp				
	out PORTC,temp				
	out PORTD,temp	
;-------------------------------------------------------------------------------
; Tasten																		
	cbi (TASTE_DDR) ,(TASTE_PIN_NR)	; Taste A	
	sbi (TASTE_PORT),(TASTE_PIN_NR)	; Pull-Up	
;-------------------------------------------------------------------------------
; auf AUSGANG																	
	sbi (BEEP_DDR),(BEEP_PIN_NR)		; BEEP		
	BEEP_OFF							; BEEP  off	
; Digit auf AUSGANG																
	sbi(A0_DDR),(A0_PIN_NR)
	sbi(A1_DDR),(A1_PIN_NR)
	sbi(A2_DDR),(A2_PIN_NR)
	sbi(A3_DDR),(A3_PIN_NR)
; Digit ON																		
	A0_ON
	A1_ON
	A2_ON
	A3_ON
; Balken auf Ausgang															
	sbi(a_DDR),(a_PIN_NR)
	sbi(b_DDR),(b_PIN_NR)
	sbi(c_DDR),(c_PIN_NR)
	sbi(d_DDR),(d_PIN_NR)
	sbi(e_DDR),(e_PIN_NR)
	sbi(f_DDR),(f_PIN_NR)
	sbi(g_DDR),(g_PIN_NR)
	sbi(DP_DDR),(DP_PIN_NR)
; Balken ON																	
	a_ON
	b_ON
	c_ON
	d_ON
	e_ON
	f_ON
	g_ON
	DP_ON
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_STOP:
	WDR
	rcall PROGRAMM_CHECK					
	rjmp PROGRAMM_STOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_ERROR
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_ERROR
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_ERROR
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_ERROR
ret
;-------------------------------------------------------------------------------
PROGRAMM_CHECK_ERROR:
	A0_ON
	A1_ON
	A2_ON
	A3_ON
	a_ON
	b_ON
	c_ON
	d_ON
	e_ON
	f_ON
	g_ON
	DP_ON
	rjmp PROGRAMM_CHECK_ERROR
; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY_VOLL:
	STS(adr_DIGIT3),VOLL
	STS(adr_DIGIT2),VOLL
	STS(adr_DIGIT1),VOLL
	STS(adr_DIGIT0),VOLL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY_CLEAR:
	STS(adr_DIGIT3),NULL
	STS(adr_DIGIT2),NULL
	STS(adr_DIGIT1),NULL
	STS(adr_DIGIT0),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
DISPLAY_PUNKT:
	ldi temp,(ASCII_PUNKT)
	STS(adr_DIGIT3),temp
	STS(adr_DIGIT2),temp
	STS(adr_DIGIT1),temp
	STS(adr_DIGIT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
TASTEN_WAIT:
	LDS temp,(adr_TASTE)
	tst temp
	brne TASTEN_WAIT_RUN
	rcall WAIT_100ms
	ret
;-------------------------------------------------------------------------------
TASTEN_WAIT_RUN:
	rcall WAIT_100ms
	STS(adr_TASTE),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP_KURZ:
	BEEP_ON
	rcall WAIT_20ms
	BEEP_OFF	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
BEEP:
	BEEP_ON
	rcall WAIT_1s
	BEEP_OFF
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; VERSION: 07/2015																
;																				
;	Division 16 bit-Zahl durch 8 bit Zahl										
;																				
;	input/Output 	temp1 (LOW)													
;	input/Output 	temp2 (HIGH)												
;																				
;	input			temp3	Divisor		 										
;																				
DIVISION_16_100:
	ldi temp3,100
	; Hilfsregister sichern		
	push temp6
	push temp7
;-----------------------------------------------------------------------
	; Aufrunden halben Divisor dazuaddieren	
	mov temp,temp3
	LSR temp	
	add temp1,temp
	adc temp2,NULL
;-----------------------------------------------------------------------
	clr temp 			; Leere Hilfsregister
	ldi temp6,1			; Zhler Bit 1 auf 1 setzen)
	clr temp7
;-----------------------------------------------------------------------
div8a:
	clc 				; Carry-Bit leeren
	rol temp1 		
	rol temp2 		
	rol temp 			;  in das Hilfsregister rotieren		
	brcs div8b 			; Eine 1 ist herausgerollt, ziehe ab	
	cp temp,temp3 		; Divisionsergebnis 1 oder 0?			
	brcs div8c 			; berspringe Subtraktion, wenn kleiner	
div8b:
	sub temp,temp3	 	; Subtrahiere Divisor					
	sec 				; Setze carry-bit, Ergebnis ist eine 1	
	rjmp div8d 			
div8c:
	clc 				; Lsche carry-bit, Ergebnis ist eine 0
div8d:
	rol temp6 			; Rotiere carry-bit in das Ergebnis		
	rol temp7
	brcc div8a 			; solange Nullen aus dem Ergebnis rotieren: weitermachen
;-----------------------------------------------------------------------
	;Zurckschreiben	
	mov temp1, temp6
	mov temp2, temp7
;-----------------------------------------------------------------------
	; wieder herstellen	
	pop temp7
	pop temp6
ret
;########################################################################
;########################################################################
;########################################################################

